// Copyright (c) 2011,2016 Douglas Miller

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.sound.sampled.*;
import java.util.Date;
import java.util.Calendar;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

import java.awt.datatransfer.StringSelection;

public class gc1005 {
	final String ident = "$Id$";

	private static JFrame front_end;

	public static void main(String[] args) {
		boolean screensaver = (args.length > 0 && args[0].compareTo("-s") == 0);
		boolean xscreensaver = (System.getenv("XSCREENSAVER_WINDOW") != null);

		gc1005_Properties props = new gc1005_Properties();
		if (screensaver) {
			props.setProperty("gc1005_screensaver", "true");
			if (xscreensaver) {
				props.setProperty("gc1005_xscreensaver", "true");
			}
			props.setProperty("gc1005_auto", "true");
		}

		front_end = new JFrame("Heathkit GC-1005 Digital Clock");
		front_end.getContentPane().setName("gc1005");
		front_end.setLayout(new FlowLayout());
		front_end.setUndecorated(true);
		front_end.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		gc1005_NeBulb bulb = new gc1005_NeBulb();
		gc1005_Display disp = new gc1005_Display(props, front_end, bulb);
		gc1005_Cabinet cab = new gc1005_Cabinet();
		gc1005_Clock clock = new gc1005_Clock(props, front_end, cab, disp, bulb);
		clock.setName("Clock");

		if (screensaver) {
			front_end.getContentPane().setBackground(Color.black);
			// Need JLayeredPane so clock can be moved later... ugh.
			JLayeredPane lp = new JLayeredPane();
			lp.setOpaque(true);
			lp.setPreferredSize(Toolkit.getDefaultToolkit().getScreenSize());
			lp.setBackground(Color.black);
			// TODO: trim bounds to actual size (not yet known)
			clock.setBounds(0, 0, 350, 135);
			lp.add(clock, new Integer(1), 1);
			front_end.add(lp);
			front_end.pack();
			if (!xscreensaver) {
				front_end.addMouseListener(clock);
				front_end.addMouseMotionListener(clock);
			}
			GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().setFullScreenWindow(front_end);
			front_end.setAlwaysOnTop(true);
			Toolkit tk= front_end.getToolkit();
			front_end.setCursor(tk.createCustomCursor(tk.getImage(""),
						new Point(), "null"));
		} else {
			front_end.setBackground(new Color(0, 0, 0, 0));
			front_end.add(clock);

			// How to get accellerator working?
			//front_end.addKeyListener(clock);

			//front_end.setSize(338,133);
			front_end.pack();
		}
		front_end.setVisible(true);

		disp.start();
	}
}
