// Copyright (c) 2011,2016 Douglas Miller

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.sound.sampled.*;
import java.util.Date;
import java.util.Calendar;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

import java.awt.datatransfer.StringSelection;

class gc1005_ClockSetting extends JDialog implements ActionListener, MouseListener {
	static final long serialVersionUID = 311100500010L;

	JButton finish;
	gc1005_SettingListener listener;

	public gc1005_ClockSetting(Frame owner, gc1005_SettingListener listner) {
		super(owner);
		dialogInit();
		Color bg = new Color(75, 75, 75, 25);
		listener = listner;
		setUndecorated(true);
		setModal(true);
		//setModalityType(ModalityType.APPLICATION_MODAL);
		GridBagLayout gb = new GridBagLayout();
		setLayout(gb);
		setBackground(bg); // why is this ignored? opacity at least
		//setOpacity(1.0f);
		setSize(175,100); // thrown away by pack()?
		GridBagConstraints gc = new GridBagConstraints();
		gc.gridwidth = 1;
		gc.gridheight = 1;
		gc.insets.bottom = 0;
		gc.insets.top = 5;
		gc.insets.left = 5;
		gc.insets.right = 5;
		gc.anchor = GridBagConstraints.CENTER;
		JLabel lab = new JLabel("LEFT - Hours", SwingConstants.CENTER);
		lab.setPreferredSize(new Dimension(200, 20));
		lab.setOpaque(false);
		gc.gridx = 0;
		gc.gridy = 0;
		gb.setConstraints(lab, gc);
		++gc.gridy;
		add(lab);
		lab = new JLabel("RIGHT - Minutes, ones", SwingConstants.CENTER);
		lab.setPreferredSize(new Dimension(200, 20));
		lab.setOpaque(false);
		gb.setConstraints(lab, gc);
		++gc.gridy;
		add(lab);
		lab = new JLabel("BOTH - Minutes, tens", SwingConstants.CENTER);
		lab.setPreferredSize(new Dimension(200, 20));
		lab.setOpaque(false);
		gb.setConstraints(lab, gc);
		++gc.gridy;
		add(lab);
		finish = new JButton("Run");
		finish.setPreferredSize(new Dimension(75, 25));
		finish.setOpaque(true);
		finish.setFocusPainted(false);
		finish.setMnemonic(KeyEvent.VK_G);
		finish.addActionListener(this);
		gc.insets.top = 0;
		gc.insets.bottom = 5;
		gb.setConstraints(finish, gc);
		++gc.gridy;
		add(finish);
		addMouseListener(this);
		pack();
	}

	public void mouseClicked(MouseEvent e) { }
	public void mouseEntered(MouseEvent e) { }
	public void mouseExited(MouseEvent e) { }
	public void mousePressed(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON1) {
			listener.button1Press();
		}
		if (e.getButton() == MouseEvent.BUTTON3) {
			listener.button3Press();
		}
	}
	public void mouseReleased(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON1) {
			listener.button1Release();
		}
		if (e.getButton() == MouseEvent.BUTTON3) {
			listener.button3Release();
		}
	}

	public void actionPerformed(ActionEvent e) {
	        if (!(e.getSource() instanceof JButton)) {
	                return;
	        }
		JButton b = (JButton)e.getSource();
		if (b.getMnemonic() == KeyEvent.VK_G) {
			listener.finish();
			setVisible(false);
			return;
		}
	}
}
