// Copyright (c) 2011,2016 Douglas Miller

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.sound.sampled.*;
import java.util.Date;
import java.util.Calendar;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

import java.awt.datatransfer.StringSelection;

class gc1005_Display extends JLabel
		implements ActionListener, gc1005_SettingListener {
	static final long serialVersionUID = 311100500007L;

	javax.swing.Timer timer;
	javax.swing.Timer counter;
	gc1005_Properties _props;

	JMenuItem _menu_o;
	JMenuItem _menu_z;
	JMenuItem _menu_a;
	JMenuItem _menu_sa;
	JMenuItem _menu_st;
	public JMenuItem[] getMenu() { return new JMenuItem[]{
		_menu_z, _menu_a, _menu_o, _menu_sa, _menu_st }; }

	private static void setClipboard(String str) {
		StringSelection ss = new StringSelection(str);
		Toolkit.getDefaultToolkit().getSystemClipboard().setContents(ss, null);
	}

	String blank = "88:88:88";
	String _gap;
	String _spc1;
	// dimensions in 1/50ths of an inch
	int width = 200;
	int height = 50;
	float digitHeight = 50;
	private Clip _alarm;
	String _alarm_setting;
	boolean _alarm_enable = false;
	boolean _alarm_on = false;
	boolean _alarm_set = false;
	boolean _time_set = false;
	boolean _24hour = false;
	boolean _time_auto = false;
	boolean _clock_go = false;
	int _alarm_hour;
	int _alarm_minute;
	boolean _snoozing = false;
	int _snooze_time = 7;
	DateFormat _alarm_fmt = new SimpleDateFormat("HH:mm");
	JFrame _top;
	gc1005_NeBulb _bulb;
	long _time_offset = 0;

	int _alarm_butt = 0;
	boolean am_digit = false;
	int hr_digit = 0;
	int tm_digit = 0;
	int m_digit = 0;
	boolean button1 = false;
	boolean button3 = false;
	boolean screensaver = false;

	public void copy() {
		String s = getText();
		s = s.replaceAll(" ",":");
		s = s.replaceAll("\004",":");	// half-width gap
		s = s.replaceAll("\005","1");	// special "1"
		setClipboard(s);
	}

	public void actionPerformed(ActionEvent e) {
		// verify the action is for the timer?
		if (e.getSource() == timer) {
			// only happens in main...
			update();
		} else if (e.getSource() == counter) {
			advance();
		} else {
			// what was it? e.getSource().stop()???
		}
	}

	public gc1005_Display(gc1005_Properties props, JFrame top, gc1005_NeBulb bulb) {
		_props = props;
		_top = top;
		_bulb = bulb;
		timer = new Timer(1000, this);
		counter = new Timer(500, this);

		setText(blank);
		setForeground(Heath_Colors.neon);
		setBackground(Heath_Colors.empty);
		setOpaque(true);
		setHorizontalAlignment(SwingConstants.CENTER);

		setPreferredSize(new Dimension(width, height));
		// font setup later... in setProperties()...

		screensaver = _props.getBoolean("gc1005_screensaver");
		if (!screensaver) {
			try {
				AudioInputStream wav =
					AudioSystem.getAudioInputStream(
						new BufferedInputStream(
							gc1005.class.getResourceAsStream(
								"sounds/alarm.wav")));
				AudioFormat format = wav.getFormat();
				DataLine.Info info = new DataLine.Info(Clip.class, format);
				_alarm = (Clip)AudioSystem.getLine(info);
				_alarm.open(wav);
				//_alarm.setLoopPoints(0, 4500);
			} catch (Exception e) {
				e.printStackTrace();
				_alarm = null;
			}
			_menu_z = new JMenuItem("Snooze", KeyEvent.VK_Z);
			_menu_z.setEnabled(false);
			_menu_a = new JMenuItem("Reset Alarm", KeyEvent.VK_R);
			_menu_a.setEnabled(false);
			_menu_o = new JMenuItem("Alarm ?", KeyEvent.VK_A);
			_menu_sa = new JMenuItem("Alarm Set", KeyEvent.VK_S);
			_menu_st = new JMenuItem("Time Set", KeyEvent.VK_T);
		}
		setProperties(_props);
	}

	public void start() {
		if (_clock_go) {
			timer.start();
		}
	}

	public void setProperties(Heath_Properties p) {
		gc1005_Properties prop = (gc1005_Properties)p;
		_24hour = prop.getBoolean("gc1005_24hour");
		if (_24hour) {
			_alarm_fmt = new SimpleDateFormat("HH:mm");
		} else {
			_alarm_fmt = new SimpleDateFormat("h:mm a");
		}
		String f = prop.getProperty("gc1005_displayfont");
		Font font = null;
		java.io.InputStream ttf = this.getClass().getResourceAsStream(f);
		if (ttf != null) {
			try {
				font = Font.createFont(Font.TRUETYPE_FONT, ttf);
			} catch (FontFormatException ee) {
			} catch (IOException ee) {
			}
			font = font.deriveFont(digitHeight * 0.72f);
			if (font.canDisplay('\004')) _gap = "\004"; else _gap = " ";
			if (prop.getBoolean("gc1005_special1") && font.canDisplay('\005')) {
				_spc1 = "\005";
			} else {
				_spc1 = "1";
			}
		}
		if (font == null) {
			System.err.println("Missing font \"" +
					f + "\", using default");
			font = new Font("Monospaced", Font.PLAIN, 40);
		}
		setFont(font);
		_snooze_time = prop.getInteger("gc1005_snooze");
		_time_auto = prop.getBoolean("gc1005_auto");
		_alarm_enable = prop.getBoolean("gc1005_alarm_on");
		if (_time_auto) {
			_alarm_setting = prop.getProperty("gc1005_alarm");
			// will never be null/empty, has default of 12am.
			try {
				Calendar cal = Calendar.getInstance();
				Date dt;
				if (_alarm_setting.equalsIgnoreCase("test")) {
					_alarm_enable = true;
					dt = new java.util.Date();
					cal.setTimeInMillis(dt.getTime() + 60000);
				} else {
					dt = _alarm_fmt.parse(_alarm_setting);
					cal.setTime(dt);
				}
				_alarm_hour = cal.get(Calendar.HOUR_OF_DAY);
				_alarm_minute = cal.get(Calendar.MINUTE);
			} catch(Exception e) {
e.printStackTrace();
				_alarm_enable = false;
			}
		} else if (!_clock_go) {
			_alarm_hour = 0;
			_alarm_minute = 0;
			_alarm_setting = (_24hour ? "00:00" : "12:00 AM");
		}
		if (!screensaver) {
			int volume = prop.getInteger("gc1005_alarm_volume"); // 0-100%
			FloatControl vol = null;
			if (_alarm.isControlSupported(FloatControl.Type.MASTER_GAIN)) {
				vol = (FloatControl)_alarm.getControl(FloatControl.Type.MASTER_GAIN);
			} else if (_alarm.isControlSupported(FloatControl.Type.VOLUME)) {
				vol = (FloatControl)_alarm.getControl(FloatControl.Type.VOLUME);
			}
			if (vol != null) {
				float min = vol.getMinimum();
				float max = vol.getMaximum();
				float gain = (float)(min + ((max - min) * (volume / 100.0)));
				vol.setValue(gain);
			}
			alarm(_alarm_enable);
		}
		if (_time_auto) {
			if (!_clock_go) {
				_clock_go = true;
				start();
			}
		}
		update();
	}

	public boolean alarm() { return _alarm_enable; }
	public void alarm(boolean on) {
		_alarm_enable = on;
		_menu_o.setText("Alarm " + (_alarm_enable ? "Off" : "On"));
	}

	public void update() {
		if (_clock_go) {
			Date dt = new java.util.Date();
			if (!_time_auto) {
				dt.setTime(dt.getTime() + _time_offset);
			}
			Calendar cal = Calendar.getInstance();
			cal.setTime(dt);
			int hour = cal.get(Calendar.HOUR_OF_DAY);
			int minute = cal.get(Calendar.MINUTE);
			int second = cal.get(Calendar.SECOND);

			if (_24hour) {
				blank = String.format("%02d:%02d:%02d", hour, minute, second);
			} else {
				int hr = hour % 12;
				if (hr == 0) { hr = 12; }
				blank = String.format("%2d:%02d:%02d", hr, minute, second);
			}
			// TODO: should alarm work in screensaver mode?
			if (!screensaver && second == 0) {
				if (_snoozing && ((minute - _alarm_minute) % _snooze_time) == 0) {
					_snoozing = false;
					alarmStart();
				} else if (_alarm_enable && !_alarm_on &&
						hour == _alarm_hour && minute == _alarm_minute) {
					alarmStart();
				} else if (_alarm_on && hour != _alarm_hour && minute == _alarm_minute) {
					alarmStop();
				}
			}
		}
		String disp_a = blank.replaceAll(":", _gap);
		disp_a = disp_a.replaceAll("1", _spc1);
		setText(disp_a);
		repaint();
	}

	public void advance() {
		switch(_alarm_butt) {
		case 1:
			hr_digit += 1;
			if (_24hour) {
				if (hr_digit > 23) {
					hr_digit = 0;
				}
				am_digit = (hr_digit < 12);
			} else {
				if (hr_digit == 12) {
					am_digit = !am_digit;
				}
				if (hr_digit > 12) {
					hr_digit = 1;
				}
			}
			break;
		case 2:
			m_digit = (m_digit + 1) % 10;
			break;
		case 3:
			tm_digit = (tm_digit + 1) % 6;
			break;
		}
		set_update();
	}

	public void set_update() {
		String disp_b;
		if (_24hour) {
			disp_b = String.format("%02d:%d%d:00", hr_digit, tm_digit, m_digit);
		} else {
			disp_b = String.format("%2d:%d%d:00", hr_digit, tm_digit, m_digit);
		}
		disp_b = disp_b.replaceAll(":", _gap);
		disp_b = disp_b.replaceAll("1", _spc1);
		setText(disp_b);
		_bulb.setOn(am_digit);
		repaint();
	}

	public void alarmStart() {
		_top.toFront(); // why doesn't this work?
		_top.setAlwaysOnTop(true);
		_alarm_on = true;
		_menu_z.setEnabled(_alarm_on);
		_menu_a.setEnabled(_alarm_on);
		if (_alarm != null) {
			_alarm.setFramePosition(0);
			_alarm.loop(Clip.LOOP_CONTINUOUSLY);
		} else {
			System.err.println("No Alarm to start");
		}
	}

	public void alarmStop() {
		_top.setAlwaysOnTop(false);
		_alarm_on = false;
		_menu_z.setEnabled(_alarm_on);
		_menu_a.setEnabled(_alarm_on);
		if (_alarm != null) {
			_alarm.stop();
			_alarm.flush();
		} else {
			System.err.println("No Alarm to stop");
		}
	}

	public void alarmSnooze() {
		if (_alarm_on) {
			_snoozing = true;
			alarmStop();
		}
	}

	gc1005_ClockSetting _set_frame = null;

	public void timeSet() {
		_time_set = true;
		alarmSet();
	}

	public void alarmSet() {
		if (!_time_set) {
			_alarm_set = true;
		}
		timer.stop();
		if (_alarm_set) {
			am_digit = (_alarm_hour < 12);
			hr_digit = _alarm_hour;
			if (!_24hour) {
				hr_digit = _alarm_hour % 12;
				if (hr_digit == 0) { hr_digit = 12; }
			}
			tm_digit = _alarm_minute / 10;
			m_digit = _alarm_minute % 10;
		} else {
			if (_clock_go) {
				Date dt = new java.util.Date();
				if (!_time_auto) {
					dt.setTime(dt.getTime() + _time_offset);
				}
				Calendar cal = Calendar.getInstance();
				cal.setTime(dt);
				hr_digit = cal.get(Calendar.HOUR_OF_DAY);
				tm_digit = cal.get(Calendar.MINUTE);
				am_digit = (hr_digit < 12);
				m_digit = tm_digit % 10;
				tm_digit /= 10;
				if (!_24hour) {
					hr_digit = hr_digit % 12;
					if (hr_digit == 0) { hr_digit = 12; }
				}
			} else {
				if (_24hour) {
					hr_digit = 0;
				} else {
					hr_digit = 12;
				}
				am_digit = true;
				tm_digit = 0;
				m_digit = 0;
			}
		}
		set_update();
		if (_set_frame == null) {
			_set_frame = new gc1005_ClockSetting(_top, this);
		}
		//_set_frame.setLocationRelativeTo(_top);
		Point p = _top.getLocation();
		// TODO: these need to be scaled.
		p.x += 100;
		if (p.y > 100) {
			p.y -= 75;
		} else {
			p.y += 100;
		}
		_set_frame.setLocation(p);
		_set_frame.setVisible(true);
	}

	public void alarmSetDone() {
		_bulb.setOn(false);
		boolean set_alarm = _alarm_set;
		_alarm_set = false;
		_time_set = false;
		counter.stop(); // just in case
		if (set_alarm) {
			_alarm_hour = hr_digit;
			_alarm_minute = (tm_digit * 10) + m_digit;
			if (_24hour) {
				_alarm_setting = String.format("%02d:%02d", _alarm_hour, _alarm_minute);
			} else {
				_alarm_setting = String.format("%d:%02d %s", _alarm_hour, _alarm_minute, am_digit ? "AM" : "PM");
				if (_alarm_hour == 12) { _alarm_hour = 0; }
				if (!am_digit) { _alarm_hour += 12; }
			}
			try {
				_props.setAndSaveProperty(
					_props.getClass().newInstance(),
					"gc1005_alarm", _alarm_setting);
			} catch(Exception ee) { ee.printStackTrace(); }
		} else {
			Date dt = new java.util.Date();
			int t = hr_digit; // hours
			if (!_24hour) {
				if (t == 12) { t = 0; }
				if (!am_digit) { t += 12; }
			}
			t = (t * 60) + (tm_digit * 10) + m_digit; // minutes
			t *= 60; // seconds
			Calendar cal = Calendar.getInstance();
			cal.setTime(dt);
			int tt = cal.get(Calendar.HOUR_OF_DAY);
			tt = (tt * 60) + cal.get(Calendar.MINUTE);
			tt = (tt * 60) + cal.get(Calendar.SECOND);
			if (t < tt) { t += (24 * 60 * 60); }
			_time_offset = (t - tt) * 1000;
			_time_auto = false;
			_clock_go = true;
		}
		start();
		update();
	}

	public void button1Press() {
		if (_alarm_butt == 0) {
			counter.start();
		}
		_alarm_butt |= 1;
	}
	public void button3Press() {
		if (_alarm_butt == 0) {
			counter.start();
		}
		_alarm_butt |= 2;
	}
	public void button1Release() {
		_alarm_butt &= ~1;
		if (_alarm_butt == 0) {
			counter.stop();
		}
	}
	public void button3Release() {
		_alarm_butt &= ~2;
		if (_alarm_butt == 0) {
			counter.stop();
		}
	}

	public void finish() {
		alarmSetDone();
	}
}
